<template>
    <label for="upload-file">
        <input
            @change="onChangeFile"
            type="file"
            id="upload-file"
            class="hidden"
        />
        <span
            class="inline-flex items-center gap-1 text-white rounded-md px-5 py-2 cursor-pointer"
            :class="classCustom"
        >
            <SpinLoading v-if="isLoading" color="#ffffff" />
            <UploadIcon v-else class="text-white" />
            <span>Tải lên</span>
        </span>
    </label>
</template>

<script>
import { createToast } from "mosha-vue-toastify";

import useUploadImage from "@/hooks/upload/useUploadImage";

import { UploadIcon } from "@heroicons/vue/outline";
import SpinLoading from "@/components/loading/SpinLoading.vue";

export default {
    components: {
        UploadIcon,
        SpinLoading
    },
    props: {
        urlImage: {
            type: String,
            required: true
        },
        classCustom: {
            type: String,
            default: "bg-color-warning hover:shadow-hover-warning"
        }
    },
    setup(_, context) {
        const {
            errorResponse,
            isLoading,
            linkImage,
            onUpload
        } = useUploadImage();

        async function onChangeFile(event) {
            const selectedFile = event.target.files[0];
            const typesFile = ["image/png", "image/jpg", "image/jpeg"];

            if (selectedFile && typesFile.includes(selectedFile.type)) {
                const bodyFromData = new FormData();
                bodyFromData.append("image", selectedFile);

                await onUpload(bodyFromData);

                if (errorResponse.value) {
                    if (
                        errorResponse.value.image &&
                        errorResponse.value.image.length
                    ) {
                        createToast(errorResponse.value.image[0], {
                            showIcon: true,
                            type: "danger"
                        });
                    } else {
                        createToast("Có lỗi xảy ra, vui lòng thử lại sau", {
                            showIcon: true,
                            type: "danger"
                        });
                    }
                } else {
                    // emit url image
                    context.emit("update:urlImage", linkImage.value);
                    createToast("Tải lên thành công", {
                        showIcon: true,
                        type: "success"
                    });
                }
            } else {
                createToast(
                    "Chỉ hỗ trợ các hình ảnh có đuôi: .png, .jpg hoặc .jpge",
                    {
                        showIcon: true,
                        type: "danger"
                    }
                );
            }
        }

        return { isLoading, onChangeFile };
    }
};
</script>
